<template>
  <div>
    <base-header class="pb-6">
      <b-row class="py-4">
        <b-col lg="12" cols="7">
          <h6 class="h2 text-white d-inline-block mb-0">Project Dashboard</h6>
          <nav aria-label="breadcrumb" class="d-none d-md-inline-block ml-md-4">
            <route-bread-crumb></route-bread-crumb>
          </nav>
        </b-col>

        <b-col lg="6" cols="7">

        </b-col>

        <b-col lg="6" cols="7" >
            <card gradient="default" no-body="">
              <b-card-body>
                <div class="mb-2">
                  <div>
                    <span class="h2 text-white">Project Name : {{ model.project_name }}  </span>
                  </div>

                  <div class="text-light mt-2 text-sm">Current Project Status :
                    <span class="text-success font-weight-600"> {{ model.status.status_code }} </span>
                  </div>
                  <div class="text-light mt-2 text-sm">Project Manager :
                    <span class="text-success font-weight-600"> {{ model.project_manager.name }} </span>
                  </div>
                  <div class="text-light mt-2 text-sm">Developer :
                    <span class="text-success font-weight-600"> {{ model.developer.developer_code }} </span>
                  </div>
                </div>
              </b-card-body>
            </card>
        </b-col>

        <b-col lg="12" cols="6" class="text-right">
          <base-button size="sm" type="neutral" @click="newProjectDocument()"
          v-if="((button_access.project_document_new == 'YES') && (myUserID.email == model.project_manager.email))">Create New Project Document</base-button>

          <!-- <base-button size="sm" type="neutral" @click="newSiteDocument()"
          v-if="button_access.site_document_new == 'YES'">Create New Site Document</base-button> -->

          <base-button size="sm" type="neutral" @click="newTask()"
          v-if="((button_access.project_task_new == 'YES') && (myUserID.email == model.project_manager.email))">Create New Project Task</base-button>

          <!-- <base-button size="sm" type="neutral" @click="newSiteTask()"
          v-if="button_access.site_task_new == 'YES'">Create New Site Task</base-button> -->

          <base-button size="sm" type="neutral" @click="newProjectGroup()"
          v-if="((button_access.group_new == 'YES') && (myUserID.email == model.project_manager.email))">Create New Group</base-button>

          <!-- <base-button size="sm" type="neutral" @click="newProjectSite()"
          v-if="((button_access.site_new == 'YES'))">Create New Site</base-button> -->

          <!-- <base-button type="neutral" size="sm" @click="newImport()">Import Task & Document From Template</base-button> -->

          <base-button size="sm" type="neutral" @click="$router.back()">Back</base-button>
          <!-- <base-button size="sm" type="neutral" @click="modals.formTask = true">Modal</base-button> -->

        </b-col>
      </b-row>

      <b-row >
        <b-col xl="3" md="6">
          <stats-card title="Completed / Total Site Task"
                      type="gradient-red"
                      :sub-title="`${model.project_completed_task} / ${model.project_total_task}`"
                      icon="ni ni-pin-3">

            <template slot="footer">
            </template>
          </stats-card>
        </b-col>
        <b-col xl="3" md="6">
          <stats-card title="Turn On / Total (kWP)"
                      type="gradient-orange"
                      :sub-title="`${model.project_completed_capacity} / ${model.project_total_capacity} `"
                      icon="ni ni-cloud-upload-96">

            <template slot="footer">
            </template>
          </stats-card>
        </b-col>
        <b-col xl="3" md="6">
          <stats-card title="Completed / Total Site Doc."
                      type="gradient-green"
                      :sub-title="`${model.project_completed_document} / ${model.project_total_document}`"
                      icon="ni ni-bullet-list-67">

            <template slot="footer">
            </template>
          </stats-card>

        </b-col>
        <b-col xl="3" md="6">
          <stats-card title="Project Progress"
                      type="gradient-info"
                      :sub-title="`${model.project_progress} %`"
                      icon="ni ni-chart-bar-32">

            <template slot="footer">
            </template>
          </stats-card>
        </b-col>
      </b-row>
      <b-row>
        <b-col xl="6" md="6">
          <stats-card title="Completed
          / Total Project Task"
                      type="gradient-red"
                      :sub-title="`${model.project_level_completed_task} / ${model.project_level_total_task}`"
                      icon="ni ni-pin-3">

            <template slot="footer">
            </template>
          </stats-card>
        </b-col>
        <b-col xl="6" md="6">
          <stats-card title="Completed / Total Project Document"
                      type="gradient-green"
                      :sub-title="`${model.project_level_completed_document} / ${model.project_level_total_document}`"
                      icon="ni ni-bullet-list-67">

            <template slot="footer">
            </template>
          </stats-card>
        </b-col>
      </b-row>
    </base-header>

    <b-container fluid class="mt--6">
      <b-row>
        <b-col xl="6">
         <card type="default" header-classes="bg-transparent">
            <b-row align-v="center" slot="header">
              <b-col>
                <h5 class="h3 text-white mb-0">Project S-Curve</h5>
              </b-col>
              <b-col>
                <b-nav class="nav-pills justify-content-end">
                  <b-nav-item
                       class="mr-1 mr-md-0"
                       :active="bigLineChart.activeIndex === 0"
                       link-classes="py-2 px-3"
                       @click.prevent="initBigChart(0)">
                      <span class="d-none d-md-block"><b>Estimated</b></span>
                  </b-nav-item>
                  <b-nav-item
                       class="mr-1 mr-md-0"
                       :active="bigLineChart.activeIndex === 1"
                       link-classes="py-2 px-3"
                       @click.prevent="initBigChart(1)">
                      <span class="danger"><b>Actual</b></span>
                  </b-nav-item>

                </b-nav>
              </b-col>
            </b-row>
            <line-chart
              :height="610"
              ref="bigChart"
              :chart-data="bigLineChart.chartData"
              :extra-options="bigLineChart.extraOptions">
            </line-chart>
          </card>
        </b-col>
        <b-col xl="6">
            <project-view-form></project-view-form>
        </b-col>
      </b-row>
      <b-row>
          <b-col xl="5">
          <milestone-progress-track-list ref="milestoneComponent"></milestone-progress-track-list>
          </b-col>
          <b-col xl="4">
          <card>
            <h5 class="h3 mb-0" slot="header">Team Members</h5>
            <user-list></user-list>
          </card>
          </b-col>
          <b-col xl="3">
          <card>
            <h5 class="h3 mb-0" slot="header">Project Contractor List for ({{ model.project_name }})</h5>
            <contractor-list></contractor-list>
          </card>
          </b-col>
      </b-row>

      <b-row v-if="button_access.group_listing == 'YES'">
        <b-col lg="12" >
          <project-group-listing-table></project-group-listing-table>
        </b-col>
      </b-row>

      <b-row v-if="button_access.site_listing == 'YES'">
        <b-col lg="12">
          <project-site-listing-table></project-site-listing-table>
        </b-col>
      </b-row>

      <b-row v-if="button_access.project_task_listing == 'YES'">
        <b-col lg="12">
          <task-table-for-project @EventTaskListUpdate="afterUpdaterPojectTaskList()"></task-table-for-project>
        </b-col>
      </b-row>

      <b-row v-if="button_access.project_document_listing == 'YES'">
        <b-col lg="12" >
          <document-table-for-project @EventDocumentListUpdate="afterUpdateTaskList()"></document-table-for-project>
        </b-col>
      </b-row>

      <b-row v-if="button_access.site_task_listing == 'YES'">
        <b-col lg="12" >
          <project-site-task-listing-table @EventTaskListUpdate="afterUpdateTaskList()"></project-site-task-listing-table>
        </b-col>
      </b-row>

      <b-row v-if="button_access.site_document_listing == 'YES'">
        <b-col lg="12">
          <site-project-document-listing-table @EventDocumentListUpdate="afterUpdateTaskList()"></site-project-document-listing-table>
        </b-col>
      </b-row>

    </b-container>

        <modal :show.sync="modals.formTask"
                   size="lg"
                   body-classes="p-0">
              <card type="secondary"
                    header-classes="bg-transparent pb-5"
                    body-classes="px-lg-5 py-lg-5"
                    class="border-0 mb-0">
                <template>
                  <div class="text-center text-muted mb-4">
                    <h3>Populate / Import Task & Milestone Template into ( TRTP-2398 - Tengeh Reservoir Tender Project )</h3>
                  </div>
                  <b-form role="form">
                    <base-input label="Populate To Target Site" name="Task Site">
                      <select class="form-control" v-model="formModal.task_site">
                        <option value="" disabled>-- Please Select A Target Site --</option>
                        <option >SN-NT - Tengeh Reservoir North Site</option>
                        <option >SN-SH - Tengeh Reservoir South Site</option>
                        <option >SN-ET - Tengeh Reservoir East Site</option>
                        <option >SN-WT - Tengeh Reservoir West Site</option>
                      </select>
                    </base-input>
                    <base-input label="Task Template" name="Task Template">
                      <select class="form-control" v-model="formModal.task_template">
                        <option value="" disabled>-- Please Select A Task Template --</option>
                        <option value="Solar Panel Project Template">TS-SL-Temp : Solar Panel Project (No. of Task : 40)</option>
                        <option value="Power Plant Project Template">TS-PL-Temp :Power Plant Project (No. of Task : 120)</option>
                      </select>
                    </base-input>
                    <base-input label="Task Template" name="Document Template">
                      <select class="form-control">
                        <option value="" >-- Please Select A Document Template --</option>
                        <option value="Solar Panel Project Template">DT-SL-Temp : Solar Panel Document Project Template (No. of Classfication : 10)</option>
                        <option value="Power Plant Project Template">DT-PL-Temp : Power Plant Document Project Template (No. of Classfication : 12)</option>
                      </select>
                    </base-input>
                     <h5 class="text-danger"> Note : <br>
                      <i>
                      1. Please Create a New Site before Import / Populate Task & Milestone into the Site (We Recommend to Import / Populate into a New Site).
                      <br>
                      2. Import / Populate Task into existing site will only create new task (All existing TASK will still be remain intact, But import twice might cause duplication).
                      <br>
                      3. All the Milestone will be Import / Populate TOGETHER according with the "Task Template".
                      <br>
                      4. To Change Milestone please proceed to Menu >> Template >> Milestone Template.
                      <br>
                      5. To Change Task please proceed to Menu >> Template >> Task Template.
                      <br>
                      6. Task Details in Template will not have the following column :
                      <br>
                      &nbsp;&nbsp;&nbsp; a) Project & Site.
                      <br>
                      &nbsp;&nbsp;&nbsp; b) Contractor.
                      <br>
                      &nbsp;&nbsp;&nbsp; c) Progress & Status.
                      <br>
                      &nbsp;&nbsp;&nbsp; d) Est Start , End Date & Start , End Date.
                      <br>
                      7. Only Column (a) & (b) can be selected during import. Please change column of (c) & (d) on each task later.
                      <br>
                      8. System will auto generate NEW TASK ID for all the TASK import / populate from Template. But Milestone CODE will remain the same.
                      </i>
                    </h5>
                    <div class="text-center">
                      <base-button type="primary" class="my-4" @click="notifyVueFormTask()">Populate / Import Task Template</base-button>
                      <base-button type="primary" class="my-4" @click="clearModal()">Cancel</base-button>
                    </div>
                  </b-form>
                </template>
              </card>
        </modal>

        <modal :show.sync="modals.formMilestone"
                   size="xl"
                   body-classes="p-0">
              <card type="secondary"
                    header-classes="bg-transparent pb-5"
                    body-classes="px-lg-5 py-lg-5"
                    class="border-0 mb-0">
                <template>
                  <div class="text-center text-muted mb-4">
                    <h3>Milestone Template Import For ( TRTP-2398 - Tengeh Reservoir Tender Project )</h3>
                  </div>
                  <b-form role="form">
                    <base-input label="Milestone Template" name="Milestone Template">
                      <select class="form-control" v-model="formModal.milestone_template">
                        <option value="" disabled>-- Please Select A Milestone Template --</option>
                        <option value="Solar Panel Project Template">MS-SL-Temp : Solar Panel Project (No. of Milestone : 6)</option>
                        <option value="Power Plant Project Template">MS-PL-Temp : Power Plant Project (No. of Milestone : 14)</option>
                      </select>
                    </base-input>
                    <div class="text-center">
                      <base-button type="primary" class="my-4" @click="notifyVueFormMilestone()">Import Milestone Template</base-button>
                      <base-button type="primary" class="my-4" @click="clearModal()">Cancel</base-button>
                    </div>
                  </b-form>
                </template>
              </card>
        </modal>

  </div>
</template>

<script>

  import RouteBreadCrumb from '@/components/Breadcrumb/RouteBreadcrumb';
  import BaseHeader from '@/components/BaseHeader';
  import ProjectViewForm from './ProjectViewForm';

  import LineChart from '@/components/Charts/LineChart';
  import * as chartConfigs from '@/components/Charts/config';

  import UserList from './AdditionalTable/UserTable';
  import ContractorList from './AdditionalTable/ContractorTable';

  import ActivityTable from './AdditionalTable/ActivityTable';

  // import TaskTable from './Task/TaskTable';
  import MilestoneProgressTrackList from './AdditionalTable/MilestoneProgressTrackList';
  // import SiteTable from './Site/SiteTable';
  import ProjectGroupListingTable from './ProjectGroupListingTable'
  import ProjectSiteListingTable from './ProjectSiteListingTable'
  import ProjectSiteTaskListingTable from './ProjectSiteTaskListingTable'
  import TaskTableForProject from './../ProjectTask/ProjectTaskListingTable'
  import DocumentTableForProject from './../ProjectDocument/ProjectDocumentListingTable'
  import SiteProjectDocumentListingTable from './ProjectDocumentListingTable'

  import {LoginURL, clientId, clientSecret, apiDomain, getHeader, getcurrentDate} from '@/assets/js/config.js'
  import axios from 'axios'

  import { Modal } from '@/components';

  export default {
    components: {
      BaseHeader,
      RouteBreadCrumb,
      ProjectViewForm,
      LineChart,
      UserList,
      ContractorList,
      ActivityTable,
      // TaskTable,
      MilestoneProgressTrackList,
      ProjectGroupListingTable,
      ProjectSiteListingTable,
      "project-site-task-listing-table" : ProjectSiteTaskListingTable,
      "task-table-for-project" : TaskTableForProject,
      "document-table-for-project" : DocumentTableForProject,
      "site-project-document-listing-table" : SiteProjectDocumentListingTable,
      Modal,
    },
    created() {
      
      var project_task_access = JSON.parse(window.localStorage.getItem('project_task_access'))
      this.button_access.project_task_listing = project_task_access.access_listing
      this.button_access.project_task_new = project_task_access.access_create

      var project_document_access = JSON.parse(window.localStorage.getItem('project_document_access'))
      this.button_access.project_document_listing = project_document_access.access_listing
      this.button_access.project_document_new = project_document_access.access_create

      var site_task_access = JSON.parse(window.localStorage.getItem('site_task_access'))
      this.button_access.site_task_listing = site_task_access.access_listing
      this.button_access.site_task_new = site_task_access.access_create

      var site_document_access = JSON.parse(window.localStorage.getItem('site_document_access'))
      this.button_access.site_document_listing = site_document_access.access_listing
      this.button_access.site_document_new = site_document_access.access_create

      var project_group_access = JSON.parse(window.localStorage.getItem('project_group_access'))
      this.button_access.group_listing = project_group_access.access_listing
      this.button_access.group_new = project_group_access.access_create

      var project_site_access = JSON.parse(window.localStorage.getItem('project_site_access'))
      this.button_access.site_listing = project_site_access.access_listing
      this.button_access.site_new = project_site_access.access_create

      const LoginUser = JSON.parse(window.localStorage.getItem('loginUser'))
      this.myUserID = LoginUser
      
      this.getDashboardData()

      this.getTotalSite()

      this.updateSCurve()

    },
    data() {
        return {
        myUserID: null,
        button_access: {
          project_task_listing: null,
          project_task_new: null,
          project_document_listing: null,
          project_document_new: null,
          site_task_listing: null,
          site_task_new: null,
          site_document_listing: null,
          site_document_new: null,
          group_listing: null,
          group_new: null,
          site_listing: null,
          site_new: null,
        },
        model: {
          project_id: null,
          project_name: null,
          project_name: null,
          project_total_installation: 0,
          project_total_capacity: 0,
          project_completed_capacity: 0,
          project_total_task: 0,
          project_completed_task: 0,
          project_total_document: 0,
          project_completed_document: 0,
          project_progress: 0,
          project_level_total_task: 0,
          project_level_completed_task: 0,
          project_level_total_document: 0,
          project_level_completed_document: 0,
          developer:
          {
            developer_code: null,
          },
          status:
          {
              status_id: null,
              status_code: null,
          },
          project_manager:
          {
              name: null,
              email: null,
          },

        },

        project_sites: [],
        modals: {
          formTask: false,
          formMilestone: false,
        },
        formModal: {
          task_template: '',
          task_site: '',
          milestone_template: '',
        },
        bigLineChart: {
          allData: [
            [0, 20, 10, 30, 15, 40, 20, 60, 60],
            [0, 20, 5, 25, 10, 30, 15, 40, 40]
          ],
          activeIndex: 0,
          chartData: {
            datasets: [
              {
                label: 'Estimated',
                data: [],
                borderColor: '#f5365c',
                backgroundColor: '#f5365c',
              },
              {
                label: 'Actual',
                data: [],
                borderColor: '#f5365c',
                backgroundColor: '#f5365c',
              }
            ],
          },
          extraOptions: chartConfigs.blueChartOptions,
        },
      };
    },
    methods: {
      getDashboardData()
      {
        this.model.project_id = this.$route.params.id
        axios.get(apiDomain + 'project/project/'+this.model.project_id, { headers: getHeader() })
        .then ( response => {
        if (response.status === 200)
        {
            this.model.project_total_task = response.data.data[0].project_total_task
            this.model.project_total_installation = response.data.data[0].project_total_installation
            this.model.project_total_document = response.data.data[0].project_total_document
            this.model.project_progress = response.data.data[0].project_progress
            this.model.project_name = response.data.data[0].project_name
            this.model.project_name = response.data.data[0].project_name
            this.model.status.status_code = response.data.data[0].status.status_code
            this.model.project_manager.name = response.data.data[0].project_manager.name
            this.model.project_manager.email = response.data.data[0].project_manager.email
            this.model.developer.developer_code = response.data.data[0].developer.developer_code
            this.model.project_total_capacity = response.data.data[0].project_total_capacity
            this.model.project_completed_capacity = response.data.data[0].project_completed_capacity
            this.model.project_completed_task = response.data.data[0].project_completed_task
            this.model.project_completed_document = response.data.data[0].project_completed_document
            this.model.project_level_total_task = response.data.data[0].project_level_total_task
            this.model.project_level_completed_task = response.data.data[0].project_level_completed_task
            this.model.project_level_total_document = response.data.data[0].project_level_total_document
            this.model.project_level_completed_document = response.data.data[0].project_level_completed_document
        }
        })
        .catch ( error => {
            console.log(error.response.status)
            if ( error.response.status == 401)
            {
                this.$router.push('/login')
            }
        });
      },
      afterUpdaterPojectTaskList()
      {
        this.getDashboardData()
      },
      afterUpdateTaskList()
      {
        this.updateSCurve()
        this.getDashboardData()
        this.$refs.milestoneComponent.getDataListing()
      },
      updateSCurve(){
        axios.get(apiDomain + 'project/project.s_curve/' + this.model.project_id, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            this.bigLineChart.chartData = {
                datasets: [
                {
                  label: 'Estimated',
                  data: response.data.data.task_results_est,
                },
                {
                  label: 'Actual',
                  data: response.data.data.task_results_act,
                  borderColor: '#FFFFFF',
                  fontColor: '#FFFFFF',
                }],
                labels: response.data.data.labels,
            }
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Project S-Curve")
        } );
      },
      showModal()
      {
        this.modals.formTask = true
      },
      getTotalSite()
      {
          axios.get(apiDomain + 'project/project_site.show_by_project/' + this.model.project_id, { headers: getHeader() })
          .then ( response => {
            if (response.status === 200)
            {
                this.project_sites = response.data.data
            }
          })
          .catch ( error => {
              console.log(error.response.status)
              if ( error.response.status == 401)
              {
                  this.$router.push('/login')
              }
          } );
      },
      newProjectDocument()
      {
        this.$router.push({path: '/projectDocumentNewFrProject/' + this.model.project_id })
      },
      newSiteDocument()
      {
        this.$router.push({path: '/siteDocumentNewFrProject/' + this.model.project_id })
      },
      newTask()
      {
        this.$router.push({path: '/projectTaskNewFrProject/' + this.model.project_id })
      },
      newSiteTask()
      {
        this.$router.push({path: '/taskNewFrProject/' + this.model.project_id })
      },
      newProjectGroup()
      {
        this.$router.push({path: '/projectGroupNewFrProject/' + this.model.project_id })
      },
      newProjectSite()
      {
        this.$router.push({path: '/projectSiteNewFrProject/' + this.model.project_id })
      },
      backToProject()
      {
        this.$router.push({path: '/projectListing' })
      },
      newImport()
      {
        this.$router.push({path: '/importNewFrProject/' + this.model.project_id })
      },
      notready() {
          this.$notify({
          message:
            '<b>Under Developer : </b> - New Task & Populate / Import From Template function is not ready.',
          timeout: 10000,
          icon: 'ni ni-bulb-61',
          type: 'danger',
          });
      },
      notifyVueFormTask() {
        if ( this.formModal.task_template === '' || this.formModal.task_site === '' )
        {
          this.$notify({
          message:
            '<b>Task Template Input Error : </b> - Please Select A Task Template & Target Site OR press <b>CANCEL</b> to <b>EXIT</b>.',
          timeout: 10000,
          icon: 'ni ni-bulb-61',
          type: 'danger',
          });
        }
        else
        {
          this.$notify({
          message:
            '<b>Task Template (' + this.formModal.task_template + ') : </b> - Successfully Imported into ( TRTP-2398 - Tengeh Reservoir Tender Project )',
          timeout: 10000,
          icon: 'ni ni-bell-55',
          type: 'default',
          });
          this.clearModal()
        }
      },
      notifyVueFormMilestone() {
        if ( this.formModal.milestone_template === '' )
        {
          this.$notify({
          message:
            '<b>Milestone Template Input Error : </b> - Please Select A Milestone Template Or Cancel to Exit.',
          timeout: 10000,
          icon: 'ni ni-bulb-61',
          type: 'danger',
          });
        }
        else
        {
          this.$notify({
          message:
            '<b>Milestone Template (' + this.formModal.milestone_template + ') : </b> - Successfully Imported into ( TRTP-2398 - Tengeh Reservoir Tender Project )',
          timeout: 10000,
          icon: 'ni ni-bell-55',
          type: 'default',
          });
          this.clearModal()
        }
      },
      clearModal()
      {
        this.modals.formTask = false
        this.modals.formMilestone = false
        this.formModal.task_template = ''
        this.formModal.task_site = ''
        this.formModal.milestone_template = ''
      }
    }
  };
</script>
<style></style>
